routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\BooksController;
use App\Http\Controllers\DashboardController;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [BooksController::class, 'index']);
Route::resource('/books', BooksController::class);

Auth::routes();

Route::get('/home', [DashboardController::class, 'index'])->name('home');

app/Models/Book.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;
use App\Models\Author;

class Book extends Model
{
    use HasFactory;

    protected $fillable = ['title','content','author_id','price','cover','year_published'];


    /**
     * Accessor defining for last updated.
     *
     * @param  string  $value
     * @return string
     */
    public function getUpdatedAtAttribute($value)
    {
        return Carbon::parse($value)->diffForhumans();
    }

    public function author()
    {
        return $this->belongsTo(Author::class, 'author_id', 'id');
    }
}

app/Http/Controllers/BooksController.php
<?php

namespace App\Http\Controllers;

use App\Models\Book;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\File;
use Log;
use Illuminate\Support\Facades\Validator;

use Illuminate\Pagination\Paginator;
use Illuminate\Pagination\LengthAwarePaginator;

class BooksController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        
        $books = Book::orderBy('created_at', 'desc')->get()->toArray();
        
        $books = $this->paginate($books, 3);
        $books->path('');
        
        //$books = Book::orderBy('created_at', 'desc')->paginate(2);
        return view('pages.books.list', compact('books'));
    }

    public function paginate($items, $perPage = 4, $page = null)
    {
        $page = $page ?: (Paginator::resolveCurrentPage() ?: 1);
        $total = count($items);
        $currentpage = $page;
        $offset = ($currentpage * $perPage) - $perPage ;
        $itemstoshow = array_slice($items , $offset , $perPage);
        return new LengthAwarePaginator($itemstoshow ,$total ,$perPage);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        try
        {
            $validator = Validator::make($request->all(), [
                'title' => 'required|unique:books|max:255',
                //'cover' => 'required|image|mimes:jpeg,png,jpg,gif,svg|max:2048',
                'content' => 'required|max:1000',
                'price' => 'required',
                'year_published' => 'required',
            ]);

            if ($validator->fails()) {

                return redirect()->back()
                            ->withErrors($validator)
                            ->withInput();

            }
            
            $coverName = '';
            if($request->file('cover'))
            {
                $image = $request->file('cover');
                $coverName = time().'.'.$image->getClientOriginalExtension();
            }



            $book = new Book();
            $book->title = $request->get('title');
            $book->title = $request->get('title');
            $book->content = $request->get('content');
            $book->price = $request->get('price');
            $book->year_published = $request->get('year_published');
            $book->cover = $coverName;
            $book->author_id = rand(1, 10);

            if($book->save())
            {

                return response()->json($book, 200);

                
                if($request->hasFile('cover'))
                {
                        $destinationPath = public_path('/assets/books/'.$book->id.'/');

                        // If directory is not there create it.

                        if(!is_dir($destinationPath))
                        {
                            mkdir("$destinationPath");
                            chmod("$destinationPath", 0755);
                        }

                        // If directory has images clean first before upload.

                        if(!empty(scandir($destinationPath)))
                        {
                            File::cleanDirectory($destinationPath);
                        }

                        // directory is empty upload image update image name in database.

                        $image->move($destinationPath, $coverName);
                }

                return back()->with('success','Book Added Successfully');
            }
        }catch(Exception $e)
        {
            Log::error($e->getMessage());
        }

    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        return view('pages.books.single')->with('book', $book);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function edit(Book $book)
    {
        return view('pages.books.edit')->with('book', $book);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Book $book)
    {
        try
        {
            // Validate data before updating.
            $validator = Validator::make($request->all(), [
                'title' => 'max:255',
                'cover' => 'image|mimes:jpeg,png,jpg,gif,svg|max:2048',
                'content' => 'max:1000',
            ]);

            if ($validator->fails()) {
                return redirect()->back()
                            ->withErrors($validator)
                            ->withInput();

            }


            // Update data in database.

            $updated = $book->update([
                "title" => $request->get('title'),
                "content" => $request->get('content'),
                "price" => $request->get('price'),
                "year_published" => $request->get('year_published'),
            ]);

            // Image update.
            if($request->hasFile('cover'))
            {

                if($request->file('cover')) {
                    $image = $request->file('cover');
                    $name = time().'.'.$image->getClientOriginalExtension();
                    $destinationPath = public_path('/assets/books/'.$book->id.'/');

                    // If directory is not there create it.

                    if(!is_dir($destinationPath))
                    {
                        mkdir("$destinationPath");
                        chmod("$destinationPath", 0755);
                    }

                    // If directory has images clean first before upload.

                    if(!empty(scandir($destinationPath)))
                    {
                        File::cleanDirectory($destinationPath);
                    }

                    // directory is empty upload image update image name in database.

                    $image->move($destinationPath, $name);

                    $book->update([
                        'cover' => $name,
                    ]);

                    return back()->with('success','Image Upload successfully');
                }
            }


            if($updated)
            {
                return back()->with('success', 'Book details Updated successfully');
            }

            return back()->with('error', 'Something went wrong');
        }
        catch(Exception $e)
        {
            Log::error($e->getMessage());
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function destroy(Book $book)
    {

        $data = $book->delete();

        return back()->with('success','Record Deleted Successfully');
    }
}

resources/views/pages/books/edit.blade.php
@extends('layouts.app')
@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">
                    <h3>Books</h3>
                    <br>{{ __('Dashboard') }}</div>
                    @if (session('success'))
                        <div class="alert alert-success m-3" role="alert">
                            {{ session('success') }}
                        </div>
                    @else
                        @if (session('error'))
                            <div class="alert alert-danger m-3" role="alert">
                                {{ session('error') }}
                            </div>
                        @endif
                    @endif

                    @if ($errors->any())
                        <div class="alert alert-danger">
                            <ul>
                                @foreach ($errors->all() as $error)
                                    <li>{{ $error }}</li>
                                @endforeach
                            </ul>
                        </div>
                    @endif

                <div class="card-body">
                    @if(isset($book))
                    <form enctype="multipart/form-data"  method="POST" action="{{ route('books.update', ['book' => $book->id]) }}">
                        {{ csrf_field() }}
                        {{ method_field('PUT') }}
                        <div class="form-group">
                            <label for="bookCover">Cover</label>
                            <input type="file" name="cover" class="form-control" id="bookCover" aria-describedby="emailHelp">
                          </div>
                        <div class="form-group">
                          <label for="bookTitle">Book Title</label>
                          <input type="text" name="title" class="form-control" id="bookTitle" aria-describedby="emailHelp"
                          placeholder="Enter Book Title" value="{{ $book->title }}">
                        </div>
                        <div class="form-group">
                            <label for="content">Details</label>
                            <textarea class="form-control text-left" name="content" id="content" cols="30" rows="10">
                                {!! $book->content !!}
                            </textarea>
                        </div>
                        <div class="form-group">
                            <label for="bookPrice">Price</label>
                            <input type="text" class="form-control" name="price" id="bookPrice" aria-describedby="emailHelp"
                            placeholder="Enter price" value="{{ $book->price }}">
                        </div>

                        <div class="form-group">
                            <label for="yearPublished">Year Published</label>
                            <input type="text" class="form-control" name="year_published" id="yearPublished" aria-describedby="emailHelp"
                            placeholder="Enter Year Published" value="{{ $book->year_published }}">
                        </div>

                        <button type="submit" class="btn btn-primary">Update</button>
                        <a class="btn btn-primary" href="{{ url()->previous() }}">Back</a>
                      </form>
                    @endif
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('scripts')
    <script>
        $( document ).ready(function() {
            function showEditField(fieldId){
                $("#row"+fieldId).fadeIn(300);
            };
        });
    </script>
@endsection